#define MAXAREAS 20      /* Subject to change (STC) in 4.0 to 26 */
#define MAXMSGBASE 128   /* STC in 4.0 to 676 (26x26) */
#define PATHSIZE   41
#define BUFFSIZE 32768L   /* 23762 Used for working buffers */
#define OLDFREQ 1

     struct fig     /* 3.0.0 fidodoor.cfg */
          {
 unsigned int  points;                  /* points to start with.  32767=Unlimited */
 unsigned int  idlesec;                 /* secs idle, before exit          */
 unsigned int  rs232dev;                /* device number                   */
 unsigned long registered;              /* Version as x03180000 (3.1.8)    */
 unsigned int  computertype;            /* 0=ST, 1=ST/MegaTalk, 
                                           2=MegaSTe, 3=TT                 */
 unsigned char bbsname[61];             /* BBS name, used in origin line   */
 unsigned char sysopname[31];           /* Sysop's name                    */
 unsigned char logfile[PATHSIZE];       /* For error output, etc.          */
 unsigned char bbspath[PATHSIZE];       /* The main bbs path               */
 unsigned char btpath[PATHSIZE];        /* BT path                         */
 unsigned char netfiles[PATHSIZE];      /* path to netfiles                */
 unsigned char nlpath[PATHSIZE];        /* path to nodelist (FIDOuser.lst) */
 unsigned char textfiles[PATHSIZE];     /* path to text files              */
 unsigned char doorspath[PATHSIZE];     /* path to doors (FOREM/TURBO)     */
 unsigned char extnedpath[PATHSIZE];    /*  External editor path           */
 unsigned char extnedremline[21];       /*  arguments for remote           */
 unsigned char extnedlocalline[21];     /*  arguemnts for local            */
 unsigned char areaname[MAXAREAS][21];  /* Area names                      */
 unsigned int  areamsg[MAXAREAS][20];   /* Msg bases in each area          */
 unsigned char msgpath[MAXMSGBASE][PATHSIZE];     /* msg base paths        */
 unsigned char msgname[MAXMSGBASE][21]; /* Base name                       */
 unsigned int  basetype[MAXMSGBASE];    /* Type of msg base as:
                                        0=netmail, 1=echomail, 2=Localmail
                                        3=local email                      */
 unsigned int  baseaddress[MAXMSGBASE][4];   /* 0=Zone, 1=Net, 2=Node, 3=Point */
 unsigned int  nconf[MAXMSGBASE];       /* max # of messages               */
 unsigned char unused[128][PATHSIZE];   /*                                 */
 unsigned int  himsgno[MAXMSGBASE];     /* stored hi msg #'s               */
 unsigned int  basestr[MAXMSGBASE];     /*  0=QBBS/ST 1=FSC001 (not used)  */
 unsigned int  unused2[MAXMSGBASE][3];  /*                                 */
 unsigned int  pnetbase[MAXMSGBASE];    /* Primary netmail base (for Treply) */
 unsigned long alias[4];                /* Use an alias?                   */
 unsigned long misc[4];                 /* Misc Toggle Bits (left to right):
                                           0 = Allow negative points
                                           1 = Ask read new mail, lon
                                           2 = Initial alias chang ok
                                           3 = Initial name change ok
                                           4 = Ext. Ed from remote ok */
          };


     struct usr     /* fidodoor.usr 3.0.0 */
          {
 unsigned char name[31];                /* we have to remember */
 unsigned char realname[31];            /* Not an alias! */
 unsigned char aliasname[31];           /* An alias */
 unsigned int  graftype;                /* graphics type */
 unsigned int  col;                     /* width of screen */
 unsigned int  lines;                   /* screen highth */
          long points;                  /* points left, or negitive */
 unsigned int  msg_delay;               /* continues msg scrl delay time */
 unsigned int  himsgread[MAXMSGBASE];   /* duh... */
 unsigned long ranmsg[4];               /* user set bitmap of RAN messg bases */
 unsigned long subop[4];                /* Sysop fuctions on this base? */
 unsigned long area;                    /* Access to this area? */
 unsigned long readmsg[4];              /* Read this msg base? */
 unsigned long writemsg[4];             /* Write to this msg base? */
 unsigned long misc[4];                 /* Misc toggles:
                                           0 = Ed. Editor Ok
                                           1 = Line Feeds
                                           2 = Turbo reply ok
                                           3 = Freq's ok
                                           4 = Netmail File Send ok
                                           5 = Email File Send ok
                                           6 = Copy file, netmail, remote
                                           7 = Clear Screen or Blank Lines */
 unsigned int lastlevel;                /* last time loged on... */
 unsigned int  unused2;
 unsigned long unused[15];
          };


  struct _node {
    int  net;              /* net number */
    int  number;           /* node number, */
    int  cost;             /* cost per minute to call */
    char name[34];         /* node name */
    char phone[40];        /* phone number */
    char city[30];         /* city and state, */

    char password[8];      /* warning, not necessarily null terminated */
    int  realcost;         /* phone company's charge */
    int  hubnode;          /* node # of this node's hub or 0 if none */
    char rate;             /* actual baud rate divided by 300 */
    char modem;            /* modem type code (see below) */
    unsigned int flags1;   /* set of flags (see below) */
    int  reserved;         /* reserved */
   };


/*------------------------------------------------------------------------*/
/* Values for the `flags1' field                                          */
/*------------------------------------------------------------------------*/
#define B_hub      0x0001  /* node is a net hub       0000 0000 0000 0001 */
#define B_host     0x0002  /* node is a net host      0000 0000 0000 0010 */
#define B_region   0x0004  /* node is region coord    0000 0000 0000 0100 */
#define B_zone     0x0008  /* node is a zone coord    0000 0000 0000 1000 */
#define B_CM       0x0010  /* runs continuous mail    0000 0000 0001 0000 */
#define B_ores1    0x0020  /* reserved for Opus       0000 0000 0010 0000 */
#define B_ores2    0x0040  /* reserved for Opus       0000 0000 0100 0000 */
#define B_ores3    0x0080  /* reserved for Opus       0000 0000 1000 0000 */
#define B_ores4    0x0100  /* reserved for Opus       0000 0001 0000 0000 */
#define B_ores5    0x0200  /* reserved for Opus       0000 0010 0000 0000 */
#define B_res1     0x0400  /* reserved for non-Opus   0000 0100 0000 0000 */
#define B_res2     0x0800  /* reserved for non-Opus   0000 1000 0000 0000 */
#define B_res3     0x1000  /* reserved for non-Opus   0001 0000 0000 0000 */
#define B_res4     0x2000  /* reserved for non-Opus   0010 0000 0000 0000 */
#define B_res5     0x4000  /* reserved for non-Opus   0100 0000 0000 0000 */
#define B_res6     0x8000  /* reserved for non-Opus   1000 0000 0000 0000 */

/*------------------------------------------------------------------------*/
/* Values for the `modem' field                                           */
/*------------------------------------------------------------------------*/
#define M_HST      0x01    /* node uses an HST                  0000 0001 */
#define M_PEP      0x02    /* node uses a PEP modem             0000 0001 */

/*--------------------------------------------------------------------------*/
/* Nodelist.Idx                                                             */
/* (File is terminated by EOF)                                              */
/*--------------------------------------------------------------------------*/
     struct _ndi {
           int   node;          /* node number  */
           int   net;           /* net number   */
          };


struct qbbsheader
          {
unsigned  char from[36];
unsigned  char to[36];
unsigned  char subject[72];
unsigned  char time[20];      /* 24 Oct 88  13:25:00 format */
          long int stamp;     /* seconds since 01/01/1970   */
          long int msgoffset;
          int junk1;
          int replyto;
          int attributes;
          char junk2[16];
          int size;           /* msg size in bytes */
          int timesread;
          int cost;           /* cost in cents */
          int origzone;
          int orignet;
          int orignode;
          int origpoint;
          int destzone;
          int destnet;
          int destnode;
          int destpoint;
          };
          
     struct comonmsginfo      /* NOTE: All int's processor specific */
          {
          char from[36];
          char to[36];
          char subject[72];
          char datetime[20];
unsigned  int timesread;
unsigned  int replyto;
unsigned  int nextreply;
unsigned  int atr;
unsigned  int cost;
unsigned  int origzone;
unsigned  int orignet;
unsigned  int orignode;
unsigned  int origpoint;
unsigned  int destzone;
unsigned  int destnet;
unsigned  int destnode;
unsigned  int destpoint;
          char origdomain[9];
          char destdomain[9];
unsigned  long origsernumb;
unsigned  long destsernumb;
          };
          

     struct qwkmsgcfg    /* quick message packets */
          {
          char status;   /* Message status flag
                                   ' ' public
                                   '-' public and read
                                   '+' private
                                   '*' private and read */
          char number[7];     /* Message Number (as characters) */
          char date[8];       /* Date (mm-dd-yy) */
          char time[5];       /* Time (hh:mm) */
          char to[25];        /* To */
          char from[25];      /* From */
          char subject[25];   /* Subject */
          char password[12];  /* Password?? */
          char replyto[8];    /* Reply to... */
          char size[6];       /* Number of 128 byte blocks in message (including
                                  the header) */
          char killed;        /* Killed Message? 225 is active, 226 is active */
          char conference;    /* Conference number (0-255) */
          char unused[4];
          };


     struct qwkndxcfg
          {
unsigned  long msgptr;   /* Record number to point to corresponding
                            message */
          char conference;    /* Conference number (0-255) */
          };

